﻿{***************************************************************************************************
 This file is part of the GLOSSA Programming Language Interpreter (Διερμηνευτής της ΓΛΩΣΣΑΣ)
 Copyright (C) 2002-2008 Alkis Georgopoulos - http://users.sch.gr/alkisg/

 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
***************************************************************************************************}
program ConsoleGlossa;
{***************************************************************************************************
Σημειώσεις για τις κωδικοσελίδες:
- Το wine υποστηρίζει CP_UTF8 οπότε δεν έχει προβλήματα.
  Όμως έχει πρόβλημα το wineconsole, δεν κατάφερα να το κάνω να εμφανίσει ελληνικά.
  Παρατήρηση: το wineconsole υποστηρίζει WriteConsoleW, το wine από κονσόλα όχι, οπότε χρησιμοποιώ
  απλή Write με CP_UTF8.
- Τα Win9x εμφανίζουν CP_737, ή άντε το πολύ CP_1253 ώστε να φαίνονται και τα εισαγωγικά: «».
  Δεν αξίζει τον κόπο, αφήνω το CP_737 και απλά αντικαθιστώ τα εισαγωγικά με απλά: "".
- Τα WinNT μπορούν να εμφανίσουν Unicode, αλλά μόνο αν έχει οριστεί TrueType font για τα προγράμματα
  κονσόλας. Η έξοδος γίνεται κανονικά σε Unicode, τα glyphs είναι το πρόβλημα.
  Επομένως αντικαθιστώ και σ' αυτά τα εισαγωγικά και από εκεί και πέρα ας κάνει ότι θέλει ο χρήστης.
- Θα μπορούσα να χρησιμοποιήσω τη SetMultiByteConversionCodePage μια και καλή για όλα, αλλά δεν
  έχω WideExceptions για να απενεργοποιήσω τη SetMultiByteConversionCodePage(1253) του Διερμηνευτή.

Σημειώσεις για τα χρώματα:
- Στόχος είναι τα μαύρα γράμματα σε άσπρο φόντο, φαίνεται καλύτερα.
- Όμως αν κάποιος είναι ήδη σε κονσόλα και τρέχει το εκτελέσιμο ΓΛΩΣΣΑΣ (για παράδειγμα αν θέλει να
  κάνει redirection), τότε θα φαίνεται πιο ωραίο αν δεν πειράζει καθόλου τα χρώματα.
  Ενας γρήγορος τρόπος για να δω αν ήμουν από πριν σε κονσόλα είναι η θέση του κέρσορα, αν είναι
  (0,0) τότε κατά 99% είναι νέα κονσόλα.
- Στα Windows 98 υπάρχει πρόβλημα, δεν χρωματίζεται η τελευταία γραμμή, επομένως καλύτερα και
  σ' αυτήν να μην πειράζονται τα χρώματα.
- Επίσης στο wine αν και μπορεί να χρωματιστεί με escape sequences καλύτερα να μην πειράζονται τα
  χρώματα γιατί π.χ. το gnome-terminal είναι ήδη άσπρο, το konsole μαύρο, και δεν θα ξέρω τι
  χρώματα να βάλω (εφόσον υποχρεωτικά είμαι ΗΔΗ σε κονσόλα πριν την εκτέλεση του προγράμματος).
- Εν τέλει χρώματα υποστηρίζονται μόνο σε WinNT (εννοείται 2000, XP, Vista...) και με εκτέλεση
  του προγράμματος με διπλό κλικ, όχι από κονσόλα. Ε, αυτό πρέπει να είναι πάνω από 90% των
  περιπτώσεων... :-|

Δοκιμές για χρωματισμό της τελευταίας γραμμής στα Win9x:
- WriteConsoleOutputAttribute(): Όχι
- ScrollConsoleScreenBuffer(): Όχι
- SetConsoleScreenBufferSize() για να πάρει και την τελευταία γραμμή σαν buffer: Όχι
- CRT32.pas: Όχι - μάλιστα το γράφει κι αυτή σαν bug.
- http://msdn.microsoft.com/en-us/library/ms977170.aspx: Όχι
- const
  GlossaCls_com =
    #$B8#$00#$0B //MOV   AX,0B00
  + #$BB#$CF#$00 //MOV   BX,00CF
  + #$CD#$10     //INT   10
  + #$C3;        //RET
  : Ναι!!! (http://www.htl-steyr.ac.at/~morg/pcinfo/hardware/interrupts/inte6ohc.htm)
  Θα έπρεπε λοιπόν να κάνω δημιουργία αρχείου C:\Windows\Temp\GlossaCls.com, να το εκτελέσω ως
  πρόγραμμα DOS αλλά με inherited console handle και να το σβήσω στη συνέχεια.
  Όμως πάλι έχει πρόβλημα με τα χρώματα όταν γίνεται scrolling!
  Επομένως το καλύτερο που έχω να κάνω είναι ΟΝΤΩΣ να το καλώ, αλλά στη συνέχεια να μην πειράζω
  κανένα χρώμα.
  Αλλά πάλι δεν είναι σωστό, γιατί πρόκειται για αλλαγή palette, όχι background, οπότε εν
  τέλει δεν μπορώ να έχω μαύρο χρώμα στο foreground...
  ΟΚ, κάπου εδώ τα παρατάω με το χρώμα στα Win9x. Άμα κάποιος φυλακισμένος έχει περισσότερη
  όρεξη και το καταφέρει ας μου πει κι εμένα πώς το έκανε.
***************************************************************************************************}

{$APPTYPE CONSOLE}
{$R *.res}

uses
  Windows,
  SysUtils,
  Classes,
  WideStrings,
  WideStrUtils,
  uDiafora in 'uDiafora.pas',
  uEkfraseis in 'uEkfraseis.pas',
  uEvtoles in 'uEvtoles.pas',
  uLa8os in 'uLa8os.pas',
  uLektikosAvalutns in 'uLektikosAvalutns.pas',
  uProgramma in 'uProgramma.pas',
  uRu8miseis in 'uRu8miseis.pas',
  uSustatika in 'uSustatika.pas';

const
  ColBackground = BACKGROUND_BLUE or BACKGROUND_GREEN or BACKGROUND_RED or BACKGROUND_INTENSITY;
  ColInput = ColBackground or FOREGROUND_BLUE;
  ColOutput = ColBackground;
  ColInfoOutput = ColBackground or FOREGROUND_GREEN;
  ColErrorOutput = ColBackground or FOREGROUND_RED;

type
  TDiepafnProgrammatos = class(TInterfacedObject, IDiepafnProgrammatos)
  private
{IDiepafnProgrammatos}
    procedure DiadikasiaEjodou(const keimevo: WideString);
    function  DiadikasiaEisodou(const mnvuma: WideString): WideString;
    procedure DiadikasiaArxnsEvtolns;
  end;
  TClientPlatform = (Win9x, WinNT, Linux);

var
  clientPlatform: TClientPlatform = Win9x;
  CP: Cardinal = CP_OEMCP;
  conOutputHandle: THandle;
  colorsEnabled: boolean = false;
  gotMyOwnConsole: boolean;
  kwdikas: WideString;

function fWideCharToMultiByte(s: WideString; CP: Cardinal = CP_ACP): UTF8String;
// Μετατρέπει ένα Unicode αλφαριθμητικό σε codepage-based αλφαριθμητικό
// Σημείωση: τα Win95b δεν υποστηρίζουν UTF8, τα Win98 ναι.
var
  len: Integer;
begin
  len := WideCharToMultiByte(CP, 0, @s[1], -1, nil, 0, nil, nil);   //Ρώτα για το μέγεθος του buffer
  if len > 0 then
  begin
    SetLength(Result, len);               //Θέσε το μέγεθος του buffer μαζί με εξτρά null terminator
    Assert(len = WideCharToMultiByte(CP, 0, @s[1], -1, @Result[1], len, nil, nil));
    SetLength(Result, len-1);                                       //Σβήσε το εξτρά null terminator
  end
  else
    Result := '';
end;

function fMultiByteToWideChar(s: UTF8String; CP: Cardinal = CP_ACP): WideString;
// Μετατρέπει ένα codepage-based αλφαριθμητικό σε Unicode αλφαριθμητικό
// Σημείωση: τα Win95b δεν υποστηρίζουν UTF8, τα Win98 ναι.
var
  len: Integer;
begin
  Result := ' ';
  len := MultiByteToWideChar(CP, 0, PAnsiChar(s), -1, nil, 0);      //Ρώτα για το μέγεθος του buffer

  if len > 0 then
  begin
    SetLength(Result, len);               //Θέσε το μέγεθος του buffer μαζί με εξτρά null terminator
    Assert(len = MultiByteToWideChar(CP, 0, PAnsiChar(s), -1, @Result[1], len));
    SetLength(Result, len-1);                                       //Σβήσε το εξτρά null terminator
  end
  else
    Result := '';
end;

procedure InitConsole;
var
  c: TCoord;
  num: Cardinal;
  cbi: TConsoleScreenBufferInfo;
begin
  SetMultiByteConversionCodePage(1253);
  conOutputHandle := GetStdHandle(STD_OUTPUT_HANDLE);
  GetConsoleScreenBufferInfo(conOutputHandle, CBI);
  gotMyOwnConsole := (cbi.dwCursorPosition.X = 0) and (cbi.dwCursorPosition.Y = 0);
  if RunningOnWine then
  begin
    clientPlatform := Linux;
    CP := CP_UTF8;
    colorsEnabled := gotMyOwnConsole;
  end
  else if Win32Platform = VER_PLATFORM_WIN32_NT then
  begin
    clientPlatform := WinNT;
    CP := 737;               //TODO: Αν διορθώσω την ConsoleRead, να δω για 1200 = Unicode ή CP_NONE
    colorsEnabled := gotMyOwnConsole;
  end
  else
  begin
    clientPlatform := Win9x;
    CP := 737;                    //Ή CP_OEMCP, αλλά ας μείνει 737 για τυχόν Win9x με αγγλικό locale
  end;
  SetConsoleCP(CP);                     //Για να τρέχει και με το wineconsole (δηλαδή με διπλό κλικ)
  SetConsoleOutputCP(CP);     //Αλλά πιθανώς να "σώσει" την κατάσταση και σε WinNT με αγγλικό locale

  if colorsEnabled then
  begin
    SetConsoleTextAttribute(conOutputHandle, ColOutput);
    c.X := 0;
    c.Y := 0;
//TODO: Να υπολογίζω το σωστό μέγεθος με τη GetLargestConsoleWindowSize?
//Μπα, δε νομίζω ότι επιστρέφει το buffer size αλλά το window size...
    FillConsoleOutputAttribute(conOutputHandle, ColOutput, 80*300, c, num);
  end;
end;

procedure ConsoleWrite(k: WideString = ''; col: Word = 0);
var
  num: Cardinal;
begin
  if colorsEnabled and (col <> 0) then
    SetConsoleTextAttribute(conOutputHandle, col);

  if (Length(k) > 0) and (k[Length(k)] = ' ') then //Η εξομοίωση Write (όχι Writeln) του Διερμηνευτή
    SetLength(k, Length(k) - 1)
  else
    k := k + #13#10;                                    //Και οι σκέτες ΓΡΑΨΕ '' αφήνουν κενή γραμμή
  if clientPlatform <> Linux then    //TODO: Εδώ θα έπρεπε να κοιτάω και για truetype font στα WinNT
    k := WideStringReplaceAll(WideStringReplaceAll(WideStringReplaceAll(k,
         '«', '"'), '»', '"'), '΄', '''');

  if clientPlatform = WinNT then
    WriteConsoleW(conOutputHandle, @k[1], Length(k), num, nil)
  else if clientPlatform = Linux then
    Write(fWideCharToMultiByte(k, CP))
  else //Win9x
    Write(fWideCharToMultiByte(k, CP));

  if colorsEnabled and (col <> 0) then
    SetConsoleTextAttribute(conOutputHandle, ColOutput);
end;

function ConsoleRead: WideString;
var
  buffer: AnsiString;
begin
  if colorsEnabled then
    SetConsoleTextAttribute(conOutputHandle, ColInput);
  Readln(buffer); //TODO: SetMultiByteConversionCodePage(); Ή τη ReadConsoleW για Unicode στα WinNT;
  if colorsEnabled then
    SetConsoleTextAttribute(conOutputHandle, ColOutput);
  Result := fMultiByteToWideChar(buffer, CP);
end;

procedure ConsoleSetTitle(title: WideString);
begin
//Τα '98 θέλουν CP_ACP, τα XP CP_OEM, οπότε για σιγουριά (και για το wine) τους στέλνω Unicode.
  if clientPlatform = Win9x then
    SetConsoleTitleA(PAnsiChar(fWideCharToMultiByte(title, CP_ACP)))
  else
    SetConsoleTitleW(@title[1]);
end;

function LoadCodeFromResource: WideString;
//Ο κώδικας του χρήστη αποθηκεύεται σαν αρχείο PROGRAM.GLO στα HTML resources του εκτελέσιμου.
//Πρέπει να είναι σε φορμάτ UTF16 με BOM, γιατί τα Win95 δεν υποστηρίζουν UTF8.
const
  RT_HTML = Pointer(23);
var
  tmpStream: TResourceStream;
  w: TWideStrings;
begin
  Result := '';
  tmpStream := TResourceStream.Create(HInstance, 'PROGRAM.GLO', RT_HTML);
  try
    tmpStream.Seek(2, soFromBeginning);                                          //Προσπέρασε το BOM
    w := TWideStringList.Create;
    w.LoadFromStream(tmpStream);
    Result := w.Text;
  finally
    tmpStream.Free;
  end;
end;

procedure TDiepafnProgrammatos.DiadikasiaArxnsEvtolns;
begin
//Αν κάποιος θέλει να φτιάξει GUI, εδώ είναι η θέση κλειδί. Καλείται κάθε φορά πριν την εκτέλεση
//κάποιας εντολής, και "ρωτώντας" το TProgramma βρίσκουμε πλήθος ή τιμές μεταβλητών κτλ.
end;

function TDiepafnProgrammatos.DiadikasiaEisodou(const mnvuma: WideString): WideString;
begin
  Result := ConsoleRead;
end;

procedure TDiepafnProgrammatos.DiadikasiaEjodou(const keimevo: WideString);
begin
  ConsoleWrite(keimevo);
end;

var
  eg: TDiepafnProgrammatos;
  p: TProgramma;
begin
  InitConsole;
  kwdikas := LoadCodeFromResource;

  eg := TDiepafnProgrammatos.Create;
  p := TProgramma.Create(eg);
  if p.Metaglwttisn(kwdikas) then
  begin           //Θέσε για τίτλο της κονσόλας τον τίτλο του προγράμματος, αλλά άλλαξε τα _ με κενά
    ConsoleSetTitle(WideStringReplaceAll(p.KP.ovoma.Kwdikas, '_', ' '));
    p.Aitnsn := aiSuvexisnEktelesns;
  end;

  ConsoleWrite;
  if p.la8os.mnvuma = '' then
    ConsoleWrite(p.la8os.tupos, ColInfoOutput)
  else begin
    ConsoleWrite(p.la8os.tupos, ColErrorOutput);
    ConsoleWrite(p.la8os.mnvuma, ColErrorOutput);
  end;
  if gotMyOwnConsole then
  begin
    ConsoleWrite('Δημιουργήθηκε με το Διερμηνευτή της ΓΛΩΣΣΑΣ - http://users.sch.gr/alkisg/'
      + #13#10 + 'Πατήστε Enter για να κλείσει το παράθυρο. ', ColInfoOutput);
    if ConsoleRead = 'alkisg' then                     //Useful easter egg! Don't tell the students!
    begin
      ConsoleWrite(kwdikas);
      ConsoleRead;
    end;

  end;
end.
