{***************************************************************************************************
 This file is part of the GLOSSA Programming Language Interpreter (  )
 Copyright (C) 2002-2008 Alkis Georgopoulos - http://users.sch.gr/alkisg/

 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
***************************************************************************************************}
unit uDiafora;
{***************************************************************************************************
    ,    .
***************************************************************************************************}

interface
uses
  Windows, WideStrings, SysUtils, WideStrUtils;

type
  TByteDynArray = array of byte;

var
  greekMonoFont: WideString = 'Courier';
  appPath: WideString = '';
  screenBpp: Integer = 8;

procedure GrngornPros8esnWideString(const apo: WideString;
  var pros: WideString; var pragmatikoMnkos: Integer; const pososto: Integer);
function GetTextStr(ts: TWideStrings; LineBreak: WideString = ''): WideString;
function RunningOnWine: boolean;

implementation

procedure GrngornPros8esnWideString(const apo: WideString;
  var pros: WideString; var pragmatikoMnkos: Integer; const pososto: Integer);
var
  epi8nmntoMnkos : Integer;
begin
  if Length(apo) = 0 then
    Exit;
  epi8nmntoMnkos := pragmatikoMnkos + Length(apo);
  if Length(pros) < epi8nmntoMnkos  then
    SetLength(pros, MulDiv(epi8nmntoMnkos, 100 + pososto, 100));
  WStrCopy(@pros[pragmatikoMnkos + 1], PWideChar(apo));
  pragmatikoMnkos := epi8nmntoMnkos;
end;

procedure GrngornPros8esnAnsiString(const apo: AnsiString;
  var pros: AnsiString; var pragmatikoMnkos: Integer; const pososto: Integer);
var
  epi8nmntoMnkos : Integer;
begin
  if Length(apo) = 0 then
    Exit;
  epi8nmntoMnkos := pragmatikoMnkos + Length(apo);
  if Length(pros) < epi8nmntoMnkos  then
    SetLength(pros, MulDiv(epi8nmntoMnkos, 100 + pososto, 100));
  StrCopy(@pros[pragmatikoMnkos + 1], @apo[1]);
  pragmatikoMnkos := epi8nmntoMnkos;
end;

function GetTextStr(ts: TWideStrings; LineBreak: WideString = ''): WideString;
{***************************************************************************************************
    WideStrings.GetTextStr,        LineBreak   
 sLineBreak.
   bug  Delphi,   Classes.TStrings.GetTextStr   LineBreak.
       strings        
 , ..
 ts := TWideStringList.Create;
 repeat
   ts.Add(something);
 until EnoughAdded;
 wholeString := GetTextStr(ts, '');
***************************************************************************************************}
var
  I, L, Size, Count: Integer;
  P: PwideChar;
  S, LB: WideString;
begin
  Count := ts.Count;
  Size := 0;
  LB := LineBreak; //[Alkis] it was sLineBreak, which is wrong
  for I := 0 to Count - 1 do Inc(Size, Length(ts[I]) + Length(LB));
  SetString(Result, nil, Size);
  P := Pointer(Result);
  for I := 0 to Count - 1 do
  begin
    S := ts[I];
    L := Length(S);
    if L <> 0 then
    begin
      System.Move(Pointer(S)^, P^, L*SizeOf(WideChar));
      Inc(P, L);
    end;
    L := Length(LB);
    if L <> 0 then
    begin
      System.Move(Pointer(LB)^, P^, L*SizeOf(WideChar));
      Inc(P, L);
    end;
  end;
end;

function RunningOnWine: boolean;
var
  module: THandle;
  wine_get_version: function: pchar; {$IFDEF Win32} stdcall; {$ENDIF}
  wine_nt_to_unix_file_name: procedure(p1:pointer; p2:pointer); {$IFDEF Win32} stdcall; {$ENDIF}
begin
  module := LoadLibrary('ntdll.dll');
  if (module <= 32) then
    Result := false
  else begin
     wine_get_version := GetProcAddress(module, 'wine_get_version');
     wine_nt_to_unix_file_name:= GetProcAddress(module, 'wine_nt_to_unix_file_name');
     FreeLibrary(module);
     Result := Assigned(wine_get_version) or Assigned(wine_nt_to_unix_file_name);
//     if Result then
//       Write('Running on Wine ' + wine_get_version + ' - nice! ;-)'#13#10);
   end;
end;

end.
