{***************************************************************************************************
 This file is part of the GLOSSA Programming Language Interpreter (  )
 Copyright (C) 2002-2008 Alkis Georgopoulos - http://users.sch.gr/alkisg/

 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
***************************************************************************************************}
unit uLektikosAvalutns;
{***************************************************************************************************
        PWideChar     .
             :
 * , .          SubStr.
 * .
***************************************************************************************************}

interface

uses
  StrUtils, WideStrUtils, SysUtils, Windows, uRu8miseis;

const
  tkAgglika              = 257;
  tkAkeraios             = 258;
  tkAkuro                = 259;
  tkAlfari8mntiko        = 260;
  tkAvagvwristiko        = 261;
  tkAvoixtoAlfari8mntiko = 262;
  tkDesmeumevnLejn       = 263;
  tkKevo                 = 264;
  tkPragmatikos          = 265;
  tkSumbolo              = 266;
  tkSxolio               = 267;
  tkTelos                = 268;
  wAlfaTovos = #$0386;
  wEyilovTovos = #$0388;
  wwmegaTovos = #$03CE;
  wAva8esnTimns = #8592;
  wDiaforo = #8800;
  wMikroteroHIso = #8804;
  wMegaluteroHIso = #8805;
  WBR = WideString(#13#10);
type
  TTuposSustatikou = (                  //   ,     
   sTelosArxeiou, sKevo, sTelosGrammns, sAkuro, sSxolio,
   sAkeraiaSt, sPragmatiknSt, sAlfari8mntiknSt, sAvoixtnAlfari8mntiknSt,
//   ,    DL.    TEkfrasnSta8eras.Create
   sAvagvwristiko,
//      
   sTRMLow,
   sAmp = sTRMLow, sArParev8esn, sDeParev8esn, sEpi, sMovadiaioSuv, sDuadikoSuv, sKomma,
   sMovadiaioMeiov, sDuadikoPlnv, sDiastnma, sDia, sAvwKatwTeleia, sMikrotero, sAva8esnTimnsANSI,
   sMikroteroHIsoANSI, sDiaforoANSI, sIsov, sMegalutero, sMegaluteroHIsoANSI, sArAgkuln, sDeAgkuln,
   sDuvamn, sAva8esnTimnsUNICODE, sDiaforoUNICODE, sMikroteroHIsoUNICODE, sMegaluteroHIsoUNICODE,
   sTRMHigh = sMegaluteroHIsoUNICODE,
// div  mod  DL.   TAploSustatiko.Create.
//         KefalaiaAtova
   sDLLow,
   sDiv = sDLLow, sMod, sA_M, sA_T, sAkeraia, sAkeraies, sAln8ns, sAlliws, sAlliws_Av, sAv, sApo,
   sArxn, sArxn_Epavalnyns, sBnma, sGia, sGraye, sDiabase, sDiadikasia, sE, sEpavalabe, sEpileje,
   sEF, sH, sHM, sKai, sKalese, sLOG, sLogikes, sLogikn, sMe, sMe_Bnma, sMetablntes, sMexri,
   sMexris_Otou, sOso, sOxi, sPeriptwsn, sPragmatikes, sPragmatikn, sProgramma, sSta8eres,
//sSuv   +
   sSYNnm, sSuvartnsn, sT_R, sTelos_Av, sTelos_Diadikasias, sTelos_Epavalnyns, sTelos_Epilogwv,
   sTelos_Programmatos, sTelos_Suvartnsns, sTote, sXaraktnras, sXaraktnres, sCeudns,
   sDLHigh = sCeudns);

  TLejn = record
    tupos: TTuposSustatikou;
    kwdikas: WideString;
  end;

  TLektikosAvalutns = class
  private
    kwdikas: WideString;
    FLejn: TLejn;
    arxn, deiktns: integer;
  public
    constructor Create(const veosKwdikas: WideString);
    procedure   AvagvwriseKevo;
    procedure   AvagvwriseTelosGrammns;
    procedure   AvagvwriseAvagvwristiko;
    procedure   AvagvwriseAri8mo;
    procedure   AvagvwriseMovoAlfari8mntiko;
    procedure   AvagvwriseDiploAlfari8mntiko;
    procedure   AvagvwriseSumbolo;
    procedure   AvagvwriseSxolio;
    procedure   AvagvwriseAkuro;
    function    EpomevnLejn: TLejn;
  end;
                             
const
  sSuv = [sMovadiaioSuv, sDuadikoSuv];                                  //   sSUVnm
  sMeiov = [sMovadiaioMeiov, sDuadikoPlnv];
  sDiaforo = [sDiaforoANSI, sDiaforoUNICODE];
  sMikroteroHIso = [sMikroteroHIsoANSI, sMikroteroHIsoUNICODE];
  sMegaluteroHIso = [sMegaluteroHIsoANSI, sMegaluteroHIsoUNICODE];
  sAva8esnTimns = [sAva8esnTimnsANSI, sAva8esnTimnsUNICODE];
  pPKTS : array[TTuposSustatikou] of WideString = (         //    
   ' ', '', ' ', ' ', '',
   ' ', ' ', ' ',
   '  ', '',
   '&', '(', ')', '*', '+', '+', ',',
   '-', '-', '..', '/', ':', '<', '<-',
   '<=', '<>', '=', '>', '>=', '[', ']', '^',
   wAva8esnTimns, wDiaforo, wMikroteroHIso, wMegaluteroHIso,
   'div', 'mod', '_', '_', '', '', '', '', '_', '', '',
   '', '_', '', '', '', '', '', '', '',
   '', '', '', '', '', '', '', '', '', '', '_',
   '', '', '_', '', '', '', '', '',
   '', '', '', '', '_', '_', '_',
   '_', '_', '_', '_', '',
   '', '', '');

function EivaiKevo(const c: WideChar): boolean;
function EivaiEOL(const c: WideChar): boolean;
function EivaiAgglikoGramma(const c: WideChar): boolean;
function EivaiEllnvikoGramma(const c: WideChar): boolean;
function EivaiGramma(const c: WideChar): boolean;
function EivaiCnfio(const c: WideChar): boolean;
function EivaiSumbolo(const c: WideChar): boolean;

function PoiaDL(const dl: WideString): TTuposSustatikou;
function PoioTRM(const trm: PWideChar; mnkos: integer = 1): TTuposSustatikou;
function XarakAtovos(const c: WideChar): WideChar;
function KefalaioAtovo(const str : WideString): WideString;
function StringReplaceAll(const s, oldPattern, newPattern: AnsiString): AnsiString;
function WidePosEx(const subStr, s: WideString; offset: Integer = 1): Integer;
function WideStringReplaceAll(const s, oldPattern, newPattern: WideString): WideString;
function UnicodeTelestesSeAnsi(const apo: WideString): WideString;
function AnsiTelestesSeUnicode(const apo: WideString): WideString;
function mPKTDL(poia: TTuposSustatikou): WideString;

var
  kPKTDL: array[sDLLow .. sDLHigh] of WideString;//     

{**************************************************************************************************}
implementation
{**************************************************************************************************}

function EivaiKevo(const c: WideChar): boolean;
begin
  result := (c <= ' ') and not EivaiEOL(c);
end;

function EivaiEOL(const c: WideChar): boolean;
begin
  result := (c = #13) or (c = #10);
end;

function EivaiEllnvikoGramma(const c: WideChar): boolean;
{***************************************************************************************************
    ,   / DOS - ANSI .     .
    (;)  Unicode     ,
          .
***************************************************************************************************}
begin
  result := (c = wAlfaTovos) or (c >= wEyilovTovos) and (c <= wwmegaTovos);
end;

function EivaiAgglikoGramma(const c: WideChar): boolean;
{***************************************************************************************************
  true   c   .
***************************************************************************************************}
begin
  result := (c >= 'A') and (c <= 'Z') or (c >= 'a') and (c <= 'z');
end;

function EivaiGramma(const c: WideChar): boolean;
{***************************************************************************************************
  true   c      .
***************************************************************************************************}
begin
  result := EivaiEllnvikoGramma(c) or EivaiAgglikoGramma(c);
end;

function EivaiCnfio(const c: WideChar): boolean;
begin
  result := (c >= '0') and (c <= '9');
end;

function EivaiSumbolo(const c: WideChar): boolean;
begin
  result := (c = '&') or (c >= '(') and (c <= '/')
   or (c = ':') or (c >= '<') and (c <= '>') or (c = '[')
   or (c = ']') or (c = '^') or (c = wAva8esnTimns) or (c = wDiaforo)
   or (c = wMikroteroHIso) or (c = wMegaluteroHIso);
end;

function WSIsoMeWC(ws: WideString; const wc: PWideChar; mnkos: integer): boolean;
{***************************************************************************************************
    PoiaDL  PoioTRM  ,      WC  WS,
  WideStrings      string.
***************************************************************************************************}
var
  i: integer;
begin
  i := 1;                       //todo:   ws[i] <> #0  wC[i-1],     
  while (i <= mnkos) and (i <= Length(ws)) and (wc[i-1] <> #0) and (ws[i] = wc[i - 1]) do
    Inc(i);                                                                  //   
  result := (i > mnkos) and (Length(ws) = i - 1);                  //      
end;

function PoiaDL(const dl: WideString): TTuposSustatikou;
{***************************************************************************************************
   dl       ,   sAvagvwristiko.
   (        ),   
    hash (accossiative array).
***************************************************************************************************}
var
  m, n: TTuposSustatikou;
  atovoDl: WideString;
begin
  atovoDl := KefalaioAtovo(dl);
  m := sDLLow;
  n := sDLHigh;
  while m <= n do
  begin
    result := TTuposSustatikou(Ord(m) + (Ord(n) - Ord(m)) div 2);
    if (atovoDl = kPKTDL[result]) then Exit
    else if (atovoDl > kPKTDL[result]) then
      if m < sDLHigh then                                                                //quick fix
        m := Succ(result)                             //todo:   range error   !
      else
        break
    else
      n := Pred(result)
  end;
  result := sAvagvwristiko;
end;

function PoioTRM(const trm: PWideChar; mnkos: integer): TTuposSustatikou;
{***************************************************************************************************
    trm       .  .
   trm    ,  ,   sAkuro.
    (    WideStrings)    byte2byte
***************************************************************************************************}
var
  m, n: TTuposSustatikou;
begin
  m := sTRMLow;
  n := sTRMHigh;
  while (m <= n) do
  begin
    result := TTuposSustatikou(Ord(m) + (Ord(n) - Ord(m)) div 2);
    if WSIsoMeWC(pPKTS[result], trm, mnkos) then Exit
    else if WStrComp(trm, PWideChar(pPKTS[result])) > 0 then  //:   trm > pPKTS,
      m := Succ(result)         //  Delphi   implicit conversion  trm  WideString,
    else                             //   10000    1  !
      n := Pred(result)
  end;
  result := sAkuro;
end;

function XarakAtovos(const c: WideChar): WideChar;
{***************************************************************************************************
      c,      .
   c    ,     c.
***************************************************************************************************}
const
  KefalaiaAtova: WideString =       //  = #902   = #974    
   ''#903''#907''#909''#930'';
begin
  if EivaiEllnvikoGramma(c) then result := KefalaiaAtova[Ord(c) - 902 + 1]
  else if (c >= 'a') and (c <= 'z') then result := WideChar(Ord(c) - 32)
  else result := c;
end;

function KefalaioAtovo(const str : WideString) : WideString;
{***************************************************************************************************
   str         .
***************************************************************************************************}
var
  i: integer;
begin
  result := WideUpperCase(str);
  for i := 1 to Length(result) do result[i] := XarakAtovos(result[i]);
end;

function StringReplaceAll(const s, oldPattern, newPattern: AnsiString): AnsiString;
{***************************************************************************************************
   WideStringReplaceAll.
***************************************************************************************************}
var
  offsets: array of integer;
  ofs, lastResultOfs, lastSOfs, numOffsets, i: integer;
begin
  ofs := PosEx(oldPattern, s, 1);                      // 0   Length(oldPattern) = 0
  if ofs = 0 then
  begin
    Result := s;
    Exit;
  end;
  if Length(oldPattern) = Length(newPattern) then              //      <> 0
  begin
    Result := s;
    repeat                                                    //    ofs <> 0
      StrMove(@Result[ofs], @newPattern[1], Length(newPattern));
      ofs := PosEx(oldPattern, s, ofs + Length(oldPattern));
    until ofs = 0;
    Exit;
  end;
//   ,  Length(oldPattern) <> Length(newPattern).     offsets.
  numOffsets := 0;
  repeat                                                      //    ofs <> 0
    if numOffsets > High(offsets) then
      SetLength(offsets, 100 + MulDiv(Length(offsets), 150, 100));
    offsets[numOffsets] := ofs;
    Inc(numOffsets);
    ofs := PosEx(oldPattern, s, ofs + Length(oldPattern));
  until ofs = 0;
  SetLength(offsets, numOffsets);
//     Result.  Length(newPattern)-Length(oldPattern)    < 0.
  SetLength(Result, Length(s) + numOffsets * (Length(newPattern) - Length(oldPattern)));
//   .  xxxOfs      "".
  lastResultOfs := 1;
  lastSOfs := 1;
  for i := 0 to numOffsets - 1 do
  begin                                                                 //    
    StrMove(@Result[lastResultOfs], @s[lastSOfs], offsets[i] - lastSOfs);
    Inc(lastResultOfs, offsets[i] - lastSOfs);
    StrMove(@Result[lastResultOfs], PAnsiChar(newPattern), Length(newPattern));    // 
    Inc(lastResultOfs, Length(newPattern));
    lastSOfs := offsets[i] + Length(oldPattern);
  end;
  StrMove(@Result[lastResultOfs], @s[lastSOfs],
    Length(Result) - lastResultOfs + 1);            //      
end;

function WidePosEx(const subStr, s: WideString; offset: Integer = 1): Integer;
{***************************************************************************************************
   PosEx  StrUtils.     WStrPos     assembly.
***************************************************************************************************}
var
  pos: PWideChar;
begin
  if (offset > Length(s)) or (Length(subStr) = 0) then
    Result := 0
  else begin
    pos := WStrPos(@s[offset], @subStr[1]);
    if pos = nil then
      Result := 0
    else
      Result := pos - @s[1] + 1;
  end;
end;

function WideStringReplaceAll(const s, oldPattern, newPattern: WideString): WideString;
{***************************************************************************************************
  WideStringReplace(..., [rfReplaceAll])   ,      
   Result := Result + Copy(...);
            
   Result.
      .
 :
 *        oldPattern  WideStringReplaceAll   Copy  
     /.
 *    oldPattern   newPattern    ,    inplace.
 *   ,   offsets        oldPattern 
   NewPattern.   ,    Result     .
          Result.
 *    offsets   strings     50%. ..   oldPattern 
    1000 ,  1001  offsets    1500.
        50%   , .. 1 => 2 => 3 => 5 => 8   
    .      offsets    100.
***************************************************************************************************}
var
  offsets: array of integer;
  ofs, lastResultOfs, lastSOfs, numOffsets, i: integer;
begin
  ofs := WidePosEx(oldPattern, s, 1);                  // 0   Length(oldPattern) = 0
  if ofs = 0 then
  begin
    Result := s;
    Exit;
  end;
  if Length(oldPattern) = Length(newPattern) then              //      <> 0
  begin
    Result := s;
    repeat                                                    //    ofs <> 0
      WStrMove(@Result[ofs], @newPattern[1], Length(newPattern));
      ofs := WidePosEx(oldPattern, s, ofs + Length(oldPattern));
    until ofs = 0;
    Exit;
  end;
//   ,  Length(oldPattern) <> Length(newPattern).     offsets.
  numOffsets := 0;
  repeat                                                      //    ofs <> 0
    if numOffsets > High(offsets) then
      SetLength(offsets, 100 + MulDiv(Length(offsets), 150, 100));
    offsets[numOffsets] := ofs;
    Inc(numOffsets);
    ofs := WidePosEx(oldPattern, s, ofs + Length(oldPattern));
  until ofs = 0;
  SetLength(offsets, numOffsets);
//     Result.  Length(newPattern)-Length(oldPattern)    < 0.
  SetLength(Result, Length(s) + numOffsets * (Length(newPattern) - Length(oldPattern)));
//   .  xxxOfs      "".
  lastResultOfs := 1;
  lastSOfs := 1;
  for i := 0 to numOffsets - 1 do
  begin                                                                 //    
    WStrMove(@Result[lastResultOfs], @s[lastSOfs], offsets[i] - lastSOfs);
    Inc(lastResultOfs, offsets[i] - lastSOfs);
    WStrMove(@Result[lastResultOfs], PWideChar(newPattern), Length(newPattern));   // 
    Inc(lastResultOfs, Length(newPattern));
    lastSOfs := offsets[i] + Length(oldPattern);
  end;
//      
  if lastSOfs <= Length(s) then                            //   0  
    WStrMove(@Result[lastResultOfs], @s[lastSOfs],      //  ,   Delphi 
      Length(Result) - lastResultOfs + 1);                //range error    @s[lastSOfs]
end;

function UnicodeTelestesSeAnsi(const apo: WideString): WideString;
{***************************************************************************************************
   Unicode    <-, <>, <=, >=   Ansi .
         CF_TEXT.
***************************************************************************************************}
begin
  result := WideStringReplaceAll(apo, pPKTS[sAva8esnTimnsUNICODE], pPKTS[sAva8esnTimnsANSI]);
  result := WideStringReplaceAll(result, pPKTS[sDiaforoUNICODE], pPKTS[sDiaforoANSI]);
  result := WideStringReplaceAll(result, pPKTS[sMikroteroHIsoUNICODE], pPKTS[sMikroteroHIsoANSI]);
  result := WideStringReplaceAll(result, pPKTS[sMegaluteroHIsoUNICODE], pPKTS[sMegaluteroHIsoANSI]);
end;

function AnsiTelestesSeUnicode(const apo: WideString): WideString;
{***************************************************************************************************
   Ansi    <-, <>, <=, >=   Unicode ,
      .
***************************************************************************************************}
begin
  result := apo;
  if ru8miseis[ruAva8esnTimns].timn = 1 then
    result := WideStringReplaceAll(result, '<-', wAva8esnTimns);
  if ru8miseis[ruSugkritikoiTelestes].timn = 1 then
  begin
    result := WideStringReplaceAll(result, '<=', wMikroteroHIso);
    result := WideStringReplaceAll(result, '<>', wDiaforo);
    result := WideStringReplaceAll(result, '>=', wMegaluteroHIso);
  end;
end;

function mPKTDL(poia: TTuposSustatikou): WideString;
begin
  if ru8miseis[ruDesmeumevesLejeis].timn = 0 then result := kPKTDL[poia]
  else result := pPKTS[poia];
end;

constructor TLektikosAvalutns.Create(const veosKwdikas: WideString);
begin
  kwdikas := veosKwdikas + WBR;
//    WBR     Avagvwrise       length.
//      (     , 
//  .
//          dk,      string
//(reference counting).      dk    string,    .
  deiktns := 1;
end;

procedure TLektikosAvalutns.AvagvwriseKevo;
{***************************************************************************************************
   Enter.
***************************************************************************************************}
begin
  repeat
    Inc(deiktns);
  until not EivaiKevo(kwdikas[deiktns]);
  FLejn.tupos := sKevo;
end;

procedure TLektikosAvalutns.AvagvwriseTelosGrammns;
{***************************************************************************************************
  ,    .
***************************************************************************************************}
begin
  if (deiktns < Length(kwdikas)) and EivaiEOL(kwdikas[deiktns + 1])
   and (kwdikas[deiktns] <> kwdikas[deiktns + 1]) then                 //.. #13#13   Enter
     Inc(deiktns, 2)
  else Inc(deiktns);
  if deiktns <= Length(kwdikas) then
    FLejn.tupos := sTelosGrammns
  else begin                              //     WBR    Create
    arxn := deiktns;
    FLejn.tupos := sTelosArxeiou;
  end;
end;

procedure TLektikosAvalutns.AvagvwriseAvagvwristiko;
{***************************************************************************************************
  sAvagvwristiko   s.
***************************************************************************************************}
begin
  repeat                            // :    , _  
    Inc(deiktns);
  until not EivaiGramma(kwdikas[deiktns]) and (kwdikas[deiktns] <> '_')
   and not EivaiCnfio(kwdikas[deiktns]);
  FLejn.tupos := PoiaDL(Copy(kwdikas, arxn, deiktns - arxn));
end;

procedure TLektikosAvalutns.AvagvwriseAri8mo;
{***************************************************************************************************
     kwdikas[deiktns]  .     ,   
        sPragmatiknSt,  sAkeraiaSt.
***************************************************************************************************}
begin
  repeat
    Inc(deiktns);
  until not EivaiCnfio(kwdikas[deiktns]);
  if (kwdikas[deiktns] = '.') and EivaiCnfio(kwdikas[deiktns + 1]) then
  begin                        //   ()    ,  
    FLejn.tupos := sPragmatiknSt;
    Inc(deiktns);                                                             //  
    repeat
      Inc(deiktns);
    until not EivaiCnfio(kwdikas[deiktns]);
  end
  else FLejn.tupos := sAkeraiaSt;
end;

procedure TLektikosAvalutns.AvagvwriseMovoAlfari8mntiko;
begin
  repeat
    Inc(deiktns);
    while (kwdikas[deiktns] = '''') and (kwdikas[deiktns + 1] = '''') do
      Inc(deiktns, 2);                                           //   '' 
  until (kwdikas[deiktns] = '''') or EivaiEOL(kwdikas[deiktns]);
  if (kwdikas[deiktns] = '''') then
  begin
    Inc(deiktns);
    FLejn.tupos := sAlfari8mntiknSt;
  end
  else FLejn.tupos := sAvoixtnAlfari8mntiknSt;
end;

procedure TLektikosAvalutns.AvagvwriseDiploAlfari8mntiko;
begin
  repeat
    Inc(deiktns);
    while (kwdikas[deiktns] = '"') and (kwdikas[deiktns + 1] = '"') do
      Inc(deiktns, 2);                                           //   "" 
  until (kwdikas[deiktns] = '"') or EivaiEOL(kwdikas[deiktns]);
  if (kwdikas[deiktns] = '"') then
  begin
    Inc(deiktns);
    FLejn.tupos := sAlfari8mntiknSt;
  end
  else FLejn.tupos := sAvoixtnAlfari8mntiknSt;
end;

procedure TLektikosAvalutns.AvagvwriseSumbolo;
begin
  FLejn.tupos := PoioTRM(@kwdikas[arxn], 2);                               //  , .. ..
  if FLejn.tupos <> sAkuro then Inc(deiktns, 2)
  else begin
    FLejn.tupos := PoioTRM(@kwdikas[deiktns]);
    Inc(deiktns);
  end;
end;

procedure TLektikosAvalutns.AvagvwriseSxolio;
begin
  repeat
    Inc(deiktns);
  until EivaiEOL(kwdikas[deiktns]);
  FLejn.tupos := sSxolio;
end;

procedure TLektikosAvalutns.AvagvwriseAkuro;
begin
  Inc(deiktns);
  FLejn.tupos := sAkuro;
end;

function TLektikosAvalutns.EpomevnLejn: TLejn;
{***************************************************************************************************
    sTelosArxeiou, sKevo ( ), sEOL ( ), sAkuro, sSxolio,
 sAvoixtoAlfari8mntiko, , ,     .
***************************************************************************************************}
begin
  arxn := deiktns;
  if (deiktns > Length(kwdikas)) then FLejn.tupos := sTelosArxeiou
  else if EivaiKevo(kwdikas[deiktns]) then AvagvwriseKevo
  else if EivaiEOL(kwdikas[deiktns]) then AvagvwriseTelosGrammns
  else if EivaiGramma(kwdikas[deiktns]) then AvagvwriseAvagvwristiko
  else if EivaiCnfio(kwdikas[deiktns]) then AvagvwriseAri8mo
  else if EivaiSumbolo(kwdikas[deiktns]) then AvagvwriseSumbolo
  else if kwdikas[deiktns] = '''' then AvagvwriseMovoAlfari8mntiko
  else if kwdikas[deiktns] = '"' then AvagvwriseDiploAlfari8mntiko
  else if kwdikas[deiktns] = '!' then AvagvwriseSxolio
  else AvagvwriseAkuro;
  fLejn.kwdikas := Copy(kwdikas, arxn, deiktns - arxn);
  result := fLejn;
end;

var
  i: TTuposSustatikou;
initialization
  for i := sDLLow to sDLHigh do
    kPKTDL[i] := KefalaioAtovo(pPKTS[i]);
  DecimalSeparator := '.';
end.
