{***************************************************************************************************
 This file is part of the GLOSSA Programming Language Interpreter (  )
 Copyright (C) 2002-2008 Alkis Georgopoulos - http://users.sch.gr/alkisg/

 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
***************************************************************************************************}
unit uRu8miseis;

interface

uses
  SysUtils, Windows, Variants, {$IFNDEF CONSOLE_GLOSSA}Graphics, Dialogs,
  TntDialogs, TntSysUtils, TntForms,{$ENDIF}
  uDiafora;                                  //        CodePage

type
  TRu8misn = packed record
    diadromn, ovoma: WideString;
    timn: variant;   //todo:     cardinal,     byte type   byte category
  end;    //         ,  boolean, widestrings...
  DeiktnsRu8misewv = (ruOvomaGrammatoseirasKwdika, ruMege8osGrammatoseirasKwdika,
   ruFakelosParadeigmatwv, ruFakelosProgrammatwv, ruDejiPeri8wrio, ruKa8usternsnArgnsEktelesns,
   ruAvadiplwsnGrammwv,
   ruDekadikaCnfia, ruSnmavtikaDekadika, ruElegxosEisodou, ruPlnrnsApotimnsnSuv8nkwv,
   ruEjomoiwsnWrite, ruKevaMetajuAri8mwvStnGrace,
   ruParametrosHMSeMoires, ruArxnAsafeiwv = ruParametrosHMSeMoires, ruMa8nmatikaDivMod,
   ruAristernProsetairistikotntaDuvamns, ruKaiProngeitaiH, ruOxiSuvevwsnAlfari8mntikwv, ruMeBnma,
   ruOxiGraceDiabaseSeSuvartnseis, ruMa8nmatikoAM, ruTelosAsafeiwv = ruMa8nmatikoAM,
   ruMorfopoinsnMetaglwttisn, ruStoixisnKwdika, ruStoixisnSxoliwv,
   ruDesmeumevesLejeis, ruAva8esnTimns, ruSugkritikoiTelestes,
   ruAG, ruAGB = ruAG, ruAGU, ruAGI, ruAGS, ruAGX, ruAGF,                         // 
   ruAK, ruAKB = ruAK, ruAKU, ruAKI, ruAKS, ruAKX, ruAKF,                          // 
   ruAX, ruAXB = ruAX, ruAXU, ruAXI, ruAXS, ruAXX, ruAXF,                        // 
   ruAL, ruALB = ruAL, ruALU, ruALI, ruALS, ruALX, ruALF,                    // 
   ruAN, ruANB = ruAN, ruANU, ruANI, ruANS, ruANX, ruANF,                            //
   ruAA, ruAAB = ruAA, ruAAU, ruAAI, ruAAS, ruAAX, ruAAF,                    // 
   ruGI, ruGIB = ruGI, ruGIU, ruGII, ruGIS, ruGIX, ruGIF,                           // 
   ruGE, ruGEB = ruGE, ruGEU, ruGEI, ruGES, ruGEX, ruGEF,                         // 
   ruDL, ruDLB = ruDL, ruDLU, ruDLI, ruDLS, ruDLX, ruDLF,                          // 
   ruEX, ruEXB = ruEX, ruEXU, ruEXI, ruEXS, ruEXX, ruEXF,                          //# 
   ruEP, ruEPB = ruEP, ruEPU, ruEPI, ruEPS, ruEPX, ruEPF,                     //# 
   ruEK, ruEKB = ruEK, ruEKU, ruEKI, ruEKS, ruEKX, ruEKF,                       // 
   ruKX, ruKXB = ruKX, ruKXU, ruKXI, ruKXS, ruKXX, ruKXF,                              // 
   ruML, ruMLB = ruML, ruMLU, ruMLI, ruMLS, ruMLX, ruMLF,                           //# 
   ruOX, ruOXB = ruOX, ruOXU, ruOXI, ruOXS, ruOXX, ruOXF,                            //# 
   ruPL, ruPLB = ruPL, ruPLU, ruPLI, ruPLS, ruPLX, ruPLF,                           // 
   ruPR, ruPRB = ruPR, ruPRU, ruPRI, ruPRS, ruPRX, ruPRF,                       // 
   ruSB, ruSBB = ruSB, ruSBU, ruSBI, ruSBS, ruSBX, ruSBF,                                  //
   ruSX, ruSXB = ruSX, ruSXU, ruSXI, ruSXS, ruSXX, ruSXF,                                   //
   ruMege8osGrammatoseirasEktupwsns, ruEgxrwmnEktupwsn,
   ruXrnsnArxeiouEisodou, ruArgnEktelesn, ruProbolnPlnrousO8ovns,
   ru32bitEikovidia, ruPosostoOrizovtiasStoixisns, ruPosostoKa8etnsStoixisns);
  TRu8miseis = array[DeiktnsRu8misewv] of TRu8misn;
  Colors = (
    clBlack, clMaroon, clGreen, clOlive, clNavy, clPurple, clTeal, clSilver,
    clMoneyGreen, clSkyBlue, clCream, clMediumGray, clGray, clRed, clLime,
    clYellow, clBlue, clFuchsia, clAqua, clWhite,
    clWindow, clWindowText, clHighlightText, clHighlight);

const
  DiadromnGlwssas: WideString = 'Software\AlkisG\';

var
  arxikesRu8miseis, ru8miseis: TRu8miseis;

{$IFNDEF CONSOLE_GLOSSA}
Procedure DiabasmaRu8misewv;
Procedure Apo8nkeusnRu8misewv;
Procedure DiagrafnRu8misewv;

function DiabaseMntrwo(var v: Variant; kleidi, timn: WideString; rootKey: HKEY = HKEY_CURRENT_USER):
 boolean;
function GrayeMntrwo(v: Variant; kleidi, timn: WideString; rootKey: HKEY = HKEY_CURRENT_USER):
 boolean;
{$ENDIF}

{**************************************************************************************************}
implementation
{**************************************************************************************************}

Procedure Qese(dr: DeiktnsRu8misewv; diadromn, ovoma: WideString; timn: variant);
begin
  arxikesRu8miseis[dr].diadromn := diadromn;
  arxikesRu8miseis[dr].ovoma := ovoma;
  if VarType(timn) in [varSmallInt, varInteger, varShortInt, varByte, varWord, varLongWord,
   varInt64] then
    arxikesRu8miseis[dr].timn := VarAsType(timn, varInteger)
  else
    arxikesRu8miseis[dr].timn := timn;
end;

Procedure ProepilegmevesRu8miseis;
var
  vFalse, vTrue: Variant;              //   stack   exe  
  mege8os: integer;
begin
  vFalse := false;
  vTrue := true;
//
  Qese(ruOvomaGrammatoseirasKwdika, ' ', '', greekMonoFont);
{$IFNDEF CONSOLE_GLOSSA}
  if screen.Width <= 640 then                                          //640x480x8: 12 visible, F12|
    mege8os := 8                                                      //800x600x10: 16 visible, F11|
  else if screen.Width <= 800 then                                  //800x600x11: 14 visible, |Ptrsc
    mege8os := 10                                                    //1024x768x14: 17 visible, F1|2
  else mege8os := 13;                                                //1024x768x12: 19 visible, F1|1
{$ELSE}
  mege8os := 8;
{$ENDIF}
  Qese(ruMege8osGrammatoseirasKwdika, ' ', '', mege8os);

  Qese(ruFakelosParadeigmatwv, '', ' ', appPath + '');
  Qese(ruFakelosProgrammatwv, '', ' ', '');
  Qese(ruDejiPeri8wrio, '', ' ', 64);
  Qese(ruKa8usternsnArgnsEktelesns, '', '  ', 250);
  Qese(ruAvadiplwsnGrammwv, '', ' ', vTrue);
//
  Qese(ruDekadikaCnfia, '', ' ', 2);
  Qese(ruSnmavtikaDekadika, '', '  ', 8);
  Qese(ruElegxosEisodou, '', ' ', vTrue);
  Qese(ruPlnrnsApotimnsnSuv8nkwv, '', '   ', vTrue);
  Qese(ruEjomoiwsnWrite, '', ' Write', vTrue);
  Qese(ruKevaMetajuAri8mwvStnGrace, '', '    ', vTrue);
//
  Qese(ruParametrosHMSeMoires, '', '   ', vTrue);
  Qese(ruMa8nmatikaDivMod, '', '  div - mod', vTrue);
  Qese(ruAristernProsetairistikotntaDuvamns, '', '  ', vTrue);
  Qese(ruKaiProngeitaiH, '', '    ', vTrue);
  Qese(ruOxiSuvevwsnAlfari8mntikwv, '', '  ', vTrue);
  Qese(ruMeBnma, '', ' ', vTrue);
  Qese(ruOxiGraceDiabaseSeSuvartnseis, '', ' -   ', vTrue);
  Qese(ruMa8nmatikoAM, '', '  ', vTrue);
//
  Qese(ruMorfopoinsnMetaglwttisn, '', '   ', vTrue);
  Qese(ruStoixisnKwdika, '', ' ', vTrue);
  Qese(ruStoixisnSxoliwv, '', ' ', vTrue);
  Qese(ruDesmeumevesLejeis, '', ' ', 0);
  Qese(ruAva8esnTimns, '', ' ', 0);
  Qese(ruSugkritikoiTelestes, '', ' ', 0);
//TODO:  hack       ConsoleGlossa.exe,      
{$IFNDEF CONSOLE_GLOSSA}
// 
  Qese(ruAGB, ' ', '', vTrue);
  Qese(ruAGU, ' ', '', vFalse);
  Qese(ruAGI, ' ', '', vFalse);
  Qese(ruAGS, ' ', '', vFalse);
  Qese(ruAGX, ' ', '', clGray);
  Qese(ruAGF, ' ', '', clWindow);
  Qese(ruAKB, ' ', '', vFalse);
  Qese(ruAKU, ' ', '', vFalse);
  Qese(ruAKI, ' ', '', vFalse);
  Qese(ruAKS, ' ', '', vFalse);
  Qese(ruAKX, ' ', '', clGreen);
  Qese(ruAKF, ' ', '', clWindow);
  Qese(ruAXB, ' ', '', vTrue);
  Qese(ruAXU, ' ', '', vFalse);
  Qese(ruAXI, ' ', '', vFalse);
  Qese(ruAXS, ' ', '', vFalse);
  Qese(ruAXX, ' ', '', clBlack);
  Qese(ruAXF, ' ', '', clRed);
  Qese(ruALB, '', '', vFalse);       //TODO: " " ( 1.0 ?)
  Qese(ruALU, '', '', vFalse);
  Qese(ruALI, '', '', vTrue);
  Qese(ruALS, '', '', vFalse);
  Qese(ruALX, '', '', clPurple);
  Qese(ruALF, '', '', clWindow);
  Qese(ruANB, '', '', vFalse);
  Qese(ruANU, '', '', vFalse);
  Qese(ruANI, '', '', vFalse);
  Qese(ruANS, '', '', vFalse);
  Qese(ruANX, '', '', clWindowText);
  Qese(ruANF, '', '', clWindow);
  Qese(ruAAB, ' ', '', vFalse);
  Qese(ruAAU, ' ', '', vFalse);
  Qese(ruAAI, ' ', '', vTrue);
  Qese(ruAAS, ' ', '', vFalse);
  Qese(ruAAX, ' ', '', clRed);
  Qese(ruAAF, ' ', '', clWindow);
  Qese(ruGIB, ' ', '', vFalse);
  Qese(ruGIU, ' ', '', vFalse);
  Qese(ruGII, ' ', '', vFalse);
  Qese(ruGIS, ' ', '', vFalse);
  Qese(ruGIX, ' ', '', clWindowText);
  Qese(ruGIF, ' ', '', clYellow);
  Qese(ruGEB, ' ', '', vFalse);
  Qese(ruGEU, ' ', '', vFalse);
  Qese(ruGEI, ' ', '', vFalse);
  Qese(ruGES, ' ', '', vFalse);
  Qese(ruGEX, ' ', '', clBlack);
  Qese(ruGEF, ' ', '', $0000FF80);
  Qese(ruDLB, ' ', '', vTrue);
  Qese(ruDLU, ' ', '', vFalse);
  Qese(ruDLI, ' ', '', vFalse);
  Qese(ruDLS, ' ', '', vFalse);
  Qese(ruDLX, ' ', '', clBlue);
  Qese(ruDLF, ' ', '', clWindow);
  Qese(ruEXB, ' ', '', vFalse);
  Qese(ruEXU, ' ', '', vFalse);
  Qese(ruEXI, ' ', '', vTrue);
  Qese(ruEXS, ' ', '', vFalse);
  Qese(ruEXX, ' ', '', clBlue);
  Qese(ruEXF, ' ', '', clWindow);
  Qese(ruEPB, ' ', '', vTrue);
  Qese(ruEPU, ' ', '', vFalse);
  Qese(ruEPI, ' ', '', vFalse);
  Qese(ruEPS, ' ', '', vFalse);
  Qese(ruEPX, ' ', '', clWindowText);
  Qese(ruEPF, ' ', '', clWindow);
  Qese(ruEKB, ' ', '', vFalse);
  Qese(ruEKU, ' ', '', vFalse);
  Qese(ruEKI, ' ', '', vFalse);
  Qese(ruEKS, ' ', '', vFalse);
  Qese(ruEKX, ' ', '', clHighlightText);
  Qese(ruEKF, ' ', '', clHighlight);
  Qese(ruKXB, ' ', '', vFalse);
  Qese(ruKXU, ' ', '', vFalse);
  Qese(ruKXI, ' ', '', vFalse);
  Qese(ruKXS, ' ', '', vFalse);
  Qese(ruKXX, ' ', '', clWindowText);
  Qese(ruKXF, ' ', '', clWindow);
  Qese(ruMLB, ' ', '', vTrue);
  Qese(ruMLU, ' ', '', vFalse);
  Qese(ruMLI, ' ', '', vFalse);
  Qese(ruMLS, ' ', '', vFalse);
  Qese(ruMLX, ' ', '', clRed);
  Qese(ruMLF, ' ', '', clWindow);
  Qese(ruOXB, ' ', '', vFalse);
  Qese(ruOXU, ' ', '', vFalse);
  Qese(ruOXI, ' ', '', vFalse);
  Qese(ruOXS, ' ', '', vFalse);
  Qese(ruOXX, ' ', '', clWindowText);
  Qese(ruOXF, ' ', '', clWindow);
  Qese(ruPLB, ' ', '', vFalse);
  Qese(ruPLU, ' ', '', vFalse);
  Qese(ruPLI, ' ', '', vFalse);
  Qese(ruPLS, ' ', '', vFalse);
  Qese(ruPLX, ' ', '', clWhite);
  Qese(ruPLF, ' ', '', clRed);
  Qese(ruPRB, ' ', '', vFalse);
  Qese(ruPRU, ' ', '', vFalse);
  Qese(ruPRI, ' ', '', vFalse);
  Qese(ruPRS, ' ', '', vFalse);
  Qese(ruPRX, ' ', '', clOlive);
  Qese(ruPRF, ' ', '', clWindow);
  Qese(ruSBB, '', '', vTrue);
  Qese(ruSBU, '', '', vFalse);
  Qese(ruSBI, '', '', vFalse);
  Qese(ruSBS, '', '', vFalse);
  Qese(ruSBX, '', '', clRed);
  Qese(ruSBF, '', '', clWindow);
  Qese(ruSXB, '', '', vFalse);
  Qese(ruSXU, '', '', vFalse);
  Qese(ruSXI, '', '', vTrue);
  Qese(ruSXS, '', '', vFalse);
  Qese(ruSXX, '', '', clGray);
  Qese(ruSXF, '', '', clWindow);
{$ENDIF}
  Qese(ruMege8osGrammatoseirasEktupwsns, '', ' ', 120);
  Qese(ruEgxrwmnEktupwsn, '', ' ', vTrue);
  Qese(ruXrnsnArxeiouEisodou, '', '  ', vTrue);
  Qese(ruArgnEktelesn, '', ' ', vTrue);
  Qese(ruProbolnPlnrousO8ovns, '', '  ', vFalse);
  Qese(ru32bitEikovidia, '', '  ', screenBpp > 8);
  Qese(ruPosostoKa8etnsStoixisns, '', '  ', 272);       // 640x480
  Qese(ruPosostoOrizovtiasStoixisns, '', '  ', 333);
end;

{$IFNDEF CONSOLE_GLOSSA}
Procedure DiabasmaRu8misewv;
{***************************************************************************************************
             .   ,
    .
***************************************************************************************************}
var
  i: DeiktnsRu8misewv;
begin
  ru8miseis := ArxikesRu8miseis;
  for i := Low(ru8miseis) to High(ru8miseis) do with ru8miseis[i] do
    DiabaseMntrwo(timn, DiadromnGlwssas + '\' + diadromn, ovoma);
end;

Procedure Apo8nkeusnRu8misewv;
var
  i: DeiktnsRu8misewv;
begin
  for i := Low(ru8miseis) to High(ru8miseis) do with ru8miseis[i] do
    if timn <> ArxikesRu8miseis[i].timn then
      GrayeMntrwo(timn, DiadromnGlwssas + '\' + diadromn, ovoma)
    else RegDelValue(DiadromnGlwssas + '\' + diadromn, ovoma);
end;

Procedure DiagrafnRu8misewv;
{***************************************************************************************************
    HKCU\Software\Alkisg\    .
    .
   RegDelKey     WinNT 4.0  I.E. < 4.0,      .
***************************************************************************************************}
begin
  RegDelKey(diadromnGlwssas + '\ ');
  RegDelKey(diadromnGlwssas + '\');
  RegDelKey(diadromnGlwssas + '\ ');
  RegDelKey(diadromnGlwssas + '\ ');
  RegDelKey(diadromnGlwssas + '\ ');
  RegDelKey(diadromnGlwssas + '\');
  RegDelKey(diadromnGlwssas + '\');
  RegDelKey(diadromnGlwssas + '\ ');
  RegDelKey(diadromnGlwssas + '\ ');
  RegDelKey(diadromnGlwssas + '\ ');
  RegDelKey(diadromnGlwssas + '\ ');
  RegDelKey(diadromnGlwssas + '\ ');
  RegDelKey(diadromnGlwssas + '\ ');
  RegDelKey(diadromnGlwssas + '\ ');
  RegDelKey(diadromnGlwssas + '\ ');
  RegDelKey(diadromnGlwssas + '\ ');
  RegDelKey(diadromnGlwssas + '\ ');
  RegDelKey(diadromnGlwssas + '\ ');
  RegDelKey(diadromnGlwssas + '\ ');
  RegDelKey(diadromnGlwssas + '\');
  RegDelKey(diadromnGlwssas + '\');
  RegDelKey(diadromnGlwssas + '\');
  RegDelKey(diadromnGlwssas);
end;

function DiabaseMntrwo(var v: Variant; kleidi, timn: WideString; rootKey: HKEY = HKEY_CURRENT_USER):
 boolean;
{***************************************************************************************************
      timn   HKEY\kleidi.
     false     v    LastError.
***************************************************************************************************}
var
  w: DWORD;
  s: WideString;
begin
  case VarType(V) of
    varSmallInt, varInteger, varShortInt, varByte,
      varWord, varLongWord, varInt64, varBoolean:              //todo: check varInt64 and varBoolean
    begin
      Result := RegReadDWord(w, kleidi, timn, rootKey);
      if Result then
        v := VarAsType(w, VarType(v));
    end;
    varOleStr, varStrArg, varString:
    begin
      Result := RegReadString(s, kleidi, timn, rootKey);
      if Result then
        v := VarAsType(s, varOleStr); // VarType(v) =>   DiabaseSeiriako  v := '';
    end;
//    varInt64, varSingle, varDouble, varCurrency, varDate:
    else
    begin
      Result := false;
      WideMessageDlg('      !',
        mtError, [mbOK], 0); // 
      SetLastError(ERROR_BADKEY);
    end;
  end;
end;

function GrayeMntrwo(v: Variant; kleidi, timn: WideString;
  rootKey: HKEY = HKEY_CURRENT_USER): boolean;
{***************************************************************************************************
    v   timn   HKEY\kleidi.
    (.. )  false.
***************************************************************************************************}
var
  s: WideString;
  w: DWORD;
begin
  case VarType(V) of
    varSmallInt, varInteger, varShortInt, varByte,
      varWord, varLongWord, varInt64, varBoolean:              //todo: check varInt64 and varBoolean
    begin
      if VarType(v) <> varBoolean then
        w := v
      else if v then
        w := 1                                         //  true  -1,  0xFFFFFFFF
      else
        w := 0;
      Result := RegWriteDWord(w, kleidi, timn, rootKey);
    end;
    varOleStr, varStrArg, varString:
    begin
      s := v;
      Result := RegWriteString(s, kleidi, timn, rootKey);
    end;
//    varInt64, varSingle, varDouble, varCurrency, varDate:
    else
    begin
      Result := false;
      WideMessageDlg('     !', mtError, [mbOK], 0); // 
      SetLastError(ERROR_BADKEY);
    end;
  end;
end;
{$ENDIF}

initialization
  ProepilegmevesRu8miseis;
{$IFNDEF CONSOLE_GLOSSA}
  DiabasmaRu8misewv;
//todo: procedure CheckLoadOrder(3)        initializations
finalization
  if not commandLine.uninstall then
    Apo8nkeusnRu8misewv;
{$ENDIF}
end.
